import CronCore from '@vue-js-cron/core';

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script$1 = {
  inheritAttrs: false,
  name: 'CustomSelect',
  props: {
    multiple: {
      type: Boolean,
      default: false
    },
    value: {
      type: [String, Array, Object],
      default (props) {
        return props.multiple ? [] : null
      }
    },
    items: {
      type: Array,
      default: () => []
    },
    returnObject: {
      type: Boolean,
      default: false
    },
    itemText: {
      type: String,
      default: 'text'
    },
    itemValue: {
      type: String,
      default: 'value'
    },
    cols: {
      type: Number,
      default: 1
    },
    width: {
      type: String,
      default: 'unset'
    },
    chipProps: {
      type: Object,
      default() {
        return {}
      }
    },
    menuProps: {
      type: Object,
      default() {
        return {}
      }
    },
    selection: {
      type: String,
      default: ''
    },
    closeOnContentClick: {
      type: Boolean,
      default: true
    },
    clearable: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      menu: false
    }
  },
  computed: {
    listStyle () {
      return {
        display: (this.menu) ? 'inline-block' : 'none',
        minWidth: '5em',
        width: this.width
      }
    },
    listItemStyle () {
      return {
        width: 100 / this.cols + '%'
      }
    },
    _value () {
      return (this.multiple) ? this.value : [this.value]
    },
    selectedItems () {
      return this.items.filter((item) => {
        for (const value of this._value) {
          if (this.returnObject) {
            if (value === item) return true
          } else {
            if (value === item[this.itemValue]) return true
          }
        }
        return false
      })
    },
    selectedStr () {
      return this.selectedItems.map((item) => item[this.itemText]).join(',')
    },
    rows () {
      return Array.isArray(this.items) ? Math.ceil(this.items.length / this.cols) : 0
    },
    itemRows () {
      return Array.from(Array(this.rows), (_, i) => {
        return Array.from(Array(this.cols), (_, j) => {
          return this.items[this.cols * i + j]
        })
      })
    }
  },
  methods: {
    menuEvtListener (evt) {
      this.menu = false;
      document.removeEventListener('click', this.menuEvtListener);
    },
    toggleMenu () {
      this.menu = !this.menu;
      if (this.menu) {
        setTimeout(() => {
          document.addEventListener('click', this.menuEvtListener);
        }, 1);
      } else {
        document.removeEventListener('click', this.menuEvtListener);
      }
    },
    select (item) {
      if (this.multiple) {
        const value = this.selectedItems.slice();
        const i = this.selectedItems.indexOf(item);
        // deselect
        if (i >= 0) {
          value.splice(i, 1);
        } else { // select
          value.push(item);
        }
        this.$emit('input', (this.returnObject) ? value : value.map((item) => item[this.itemValue]));
      } else {
        this.$emit('input', (this.returnObject) ? item : item[this.itemValue]);
      }
    },
    clear () {
      this.$emit('input', this.multiple ? [] : null);
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

/* script */
const __vue_script__$1 = script$1;
/* template */
var __vue_render__$1 = function () {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "v-menu",
    _vm._b(
      {
        scopedSlots: _vm._u([
          {
            key: "activator",
            fn: function (ref) {
              var on = ref.on;
              return [
                _c(
                  "v-chip",
                  _vm._g(_vm._b({}, "v-chip", _vm.chipProps, false), on),
                  [
                    _vm._v(
                      "\n      \n      " +
                        _vm._s(
                          _vm.selection ? _vm.selection : _vm.selectedStr
                        ) +
                        "\n\n      "
                    ),
                    _vm.clearable
                      ? [
                          _vm.selectedItems.length > 0
                            ? _c(
                                "v-icon",
                                {
                                  attrs: { size: "small" },
                                  on: {
                                    click: function ($event) {
                                      $event.stopPropagation();
                                      return _vm.clear()
                                    },
                                  },
                                },
                                [_vm._v("mdi-close")]
                              )
                            : _vm._e(),
                        ]
                      : _vm._e(),
                  ],
                  2
                ),
              ]
            },
          },
        ]),
      },
      "v-menu",
      _vm.menuProps,
      false
    ),
    [
      _vm._v(" "),
      _c(
        "v-list",
        { staticClass: "pa-0 ma-0" },
        [
          _c(
            "v-list-item-group",
            { attrs: { value: _vm.selectedItems, multiple: "" } },
            _vm._l(_vm.itemRows, function (itemRow, index) {
              return _c(
                "v-row",
                { key: index, attrs: { "no-gutters": "" } },
                _vm._l(itemRow, function (item, index) {
                  return _c(
                    "v-col",
                    { key: index },
                    [
                      item
                        ? _c(
                            "v-list-item",
                            {
                              attrs: { value: item },
                              on: {
                                click: function ($event) {
                                  return _vm.select(item)
                                },
                              },
                            },
                            [_vm._v(_vm._s(item[_vm.itemText]))]
                          )
                        : _vm._e(),
                    ],
                    1
                  )
                }),
                1
              )
            }),
            1
          ),
        ],
        1
      ),
    ],
    1
  )
};
var __vue_staticRenderFns__$1 = [];
__vue_render__$1._withStripped = true;

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = undefined;
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$1 = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    undefined,
    undefined,
    undefined
  );

//

var script = {
    name: "VueCronEditor",
    components:{
        'CronCore': CronCore.component,
        CustomSelect: __vue_component__$1
    },
    props: {
        chipProps: {
            type: Object,
            default() {
                return {}
            }
        },
        menuProps: {
            type: Object,
            default() {
                return null
            }
        },
        cols: {
            type: Function,
            default(fieldId) {
                if (fieldId === 'minute') return 5
                else if (fieldId === 'hour') return 4
                else if (fieldId === 'day') return 4
                else return 1
            }
        },
        enableEveryAt: {
            type: Boolean,
            default: false
        }
    }
};

/* script */
const __vue_script__ = script;
/* template */
var __vue_render__ = function () {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c(
    "CronCore",
    _vm._b(
      {
        attrs: { enableEveryAt: _vm.enableEveryAt },
        on: {
          input: function ($event) {
            return _vm.$emit("input", $event)
          },
          error: function ($event) {
            return _vm.$emit("error", $event)
          },
        },
        scopedSlots: _vm._u([
          {
            key: "default",
            fn: function (ref) {
              var fields = ref.fields;
              var period = ref.period;
              return [
                _c(
                  "v-row",
                  { attrs: { align: "baseline", dense: "" } },
                  [
                    period.prefix
                      ? _c("v-col", { staticClass: "flex-grow-0" }, [
                          _vm._v(_vm._s(period.prefix)),
                        ])
                      : _vm._e(),
                    _vm._v(" "),
                    _c(
                      "v-col",
                      { attrs: { cols: "auto" } },
                      [
                        _c(
                          "custom-select",
                          _vm._g(
                            _vm._b(
                              {
                                attrs: {
                                  items: period.items,
                                  "item-value": "id",
                                  "menu-props": _vm.menuProps || {
                                    offsetY: true,
                                  },
                                  chipProps: _vm.chipProps,
                                },
                              },
                              "custom-select",
                              period.attrs,
                              false
                            ),
                            period.events
                          )
                        ),
                      ],
                      1
                    ),
                    _vm._v(" "),
                    period.suffix
                      ? _c("v-col", { staticClass: "flex-grow-0" }, [
                          _vm._v(_vm._s(period.suffix)),
                        ])
                      : _vm._e(),
                    _vm._v(" "),
                    _vm._l(fields, function (f) {
                      return [
                        f.prefix
                          ? _c(
                              "v-col",
                              {
                                key: f.id + "-prefix",
                                staticClass: "flex-grow-0",
                              },
                              [_vm._v(_vm._s(f.prefix))]
                            )
                          : _vm._e(),
                        _vm._v(" "),
                        _c(
                          "v-col",
                          { key: f.id, attrs: { cols: "auto" } },
                          [
                            _c(
                              "custom-select",
                              _vm._g(
                                _vm._b(
                                  {
                                    attrs: {
                                      cols: _vm.cols(f.id),
                                      items: f.items,
                                      selection: f.selectedStr,
                                      multiple: "",
                                      "menu-props": _vm.menuProps || {
                                        offsetY: true,
                                        closeOnContentClick: false,
                                      },
                                      chipProps: _vm.chipProps,
                                      clearable: true,
                                    },
                                  },
                                  "custom-select",
                                  f.attrs,
                                  false
                                ),
                                f.events
                              )
                            ),
                          ],
                          1
                        ),
                        _vm._v(" "),
                        f.suffix
                          ? _c(
                              "v-col",
                              {
                                key: f.id + "-suffix",
                                staticClass: "flex-grow-0",
                              },
                              [_vm._v(_vm._s(f.suffix))]
                            )
                          : _vm._e(),
                      ]
                    }),
                  ],
                  2
                ),
              ]
            },
          },
        ]),
      },
      "CronCore",
      _vm.$attrs,
      false
    )
  )
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

// Import vue component

// Declare install function executed by Vue.use()
function install(Vue) {
	if (install.installed) return;
	install.installed = true;
	Vue.component('CronVuetify', __vue_component__);
}

// Create module definition for Vue.use()
const plugin = {
	install,
	component: __vue_component__,
	util: CronCore.util
};

export { plugin as default, install };
